VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Thread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : Thread
' DateTime  : 09/03/2007 22:54
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Objet Thread
'---------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------
'
' Proprits
'       [statiques]
'   ID
'       [dynamiques]
'
' Mthodes
'   GetThreadByID
'   RefreshInfos
'   SuspendThread
'   ResumeThread
'
'---------------------------------------------------------------------------------------

Option Explicit

Private clsThread As New clsThreads

' Les infos sur ce thread
Private tabInfos(0 To 1) As Variant

' Les diffrentes infos du thread
Private Enum enumProcessInfo
    ethreadID = 0                                  ' L'id
End Enum



'---------------------------------------------------------------------------------------
' Les mthodes
'---------------------------------------------------------------------------------------


' Retrouve les infos statiques du thread  partir de son ID
' [Optionnel] RefreshInfos : Active ou non le rafraichissement des infos dynamiques du thread
Public Sub GetThreadByID(ByVal ThreadID As Long, Optional ByVal bRefreshInfos As Boolean = False)
    tabInfos(ethreadID) = ThreadID
    ' Les informations statiques
    ' Les informations dynamiques
    If bRefreshInfos = True Then RefreshInfos
End Sub


' Rafraichit les informations dynamiques
Public Sub RefreshInfos()
    Dim ThreadID As Long
    ThreadID = tabInfos(ethreadID)
End Sub


' Suspend l'execution du thread
Public Sub SuspendThread()
    clsThread.SuspendThread tabInfos(ethreadID)
End Sub


' Reprend l'execution d'un thread stopp
' (Note : Resume est un mot cl rserv)
Public Sub ResumeThread()
    clsThread.ResumeThread tabInfos(ethreadID)
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------

Public Property Get ID() As Long
    ID = tabInfos(ethreadID)
End Property
